// O(n)
#include <fstream>
#include <deque>
#include <vector>
using namespace std;

const int Inf = 3e4 + 1;

ifstream fin("vila2.in");
ofstream fout("vila2.out");

// v[1]  v[2] v[3] v[4] v[5]
//              j         i        

int main()
{
	int n, k;
	int dif_max = 0;
	
	fin >> n >> k;
	vector<int> v(n + 1); // v[0] .v[j] .. v[i]   v[n]
	
	// in cozi plasam pozitii din sir !
	deque<int> minQ;      // coada de minime (pe un interval de lung max k, care se termina la poz curenta)
	deque<int> maxQ;      // coada de maxime (pe un interval de lung max k, care se termina la poz curenta)  
	
	// Observatie IMPORTANTA: numarul total de operatii cu coada = n + n
	// avem n operatii push_back()  si maxim n operatii pop_front()
	
	for (int i = 1; i <= n; ++i)
	{
		fin >> v[i];
		
		while (!minQ.empty() && v[minQ.back()] >= v[i])
			minQ.pop_back();
		minQ.push_back(i);
		
		if (i - minQ.front() > k)
			minQ.pop_front();
		
		
		while (!maxQ.empty() && v[maxQ.back()] <= v[i])
			maxQ.pop_back();
		maxQ.push_back(i);
		
		if (i - maxQ.front() > k)
			maxQ.pop_front();
		
		dif_max = max(dif_max, v[maxQ.front()] - v[minQ.front()]);
		
	}
	
	fout << dif_max;
	
	return 0;
}

